Module global
    Public Const APPNAME = "OPC XML-DA Client"
    Public MAX_ELEMENTS_RET = 200
    Public Srv As OpcXmlDa = New OpcXmlDa
    Public formMainI As formMain
    Public formURLdlg As New formURL
    Public LocaleID As String = "it"
    Public BranchSepChar As String = "."
    Public itemsClipboard As New ArrayList
    Public subWinColl As SubWindowCollection

    Class SubWindowCollection
        Private Structure _SubWindowCollection
            Dim windowMenuItem As MenuItem
            Dim window As Form
            Dim valid As Boolean
        End Structure


        Const maxWins As Integer = 64
        Private subWindows(maxWins) As _SubWindowCollection
        Private windowMenu As MenuItem
        Private menuSeparator As MenuItem
        Private winsCount As Integer
        Private menuHandles(maxWins) As System.IntPtr

        Private WithEvents baseWindowMenuItem As New MenuItem
        Private Sub baseWindowMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles baseWindowMenuItem.Click
            Dim i As Integer = Array.IndexOf(menuHandles, sender.Handle)
            If i > -1 Then subWindows(i).window.Select()
        End Sub


        Sub Add(ByVal window As Form)
            Dim i As Integer
            Do Until subWindows(i).valid = False
                i += 1
                If i = maxWins Then Exit Sub
            Loop
            subWindows(i).window = window
            'subWindows(i).windowMenuItem = New MenuItem(window.Text)
            subWindows(i).windowMenuItem = baseWindowMenuItem.CloneMenu
            subWindows(i).windowMenuItem.Text = window.Text
            menuHandles(i) = subWindows(i).windowMenuItem.Handle  'servir al menu a riconoscere s stesso (a cercare il suo indice)

            windowMenu.MenuItems.Add(subWindows(i).windowMenuItem)
            window.Tag = i
            subWindows(i).valid = True
            winsCount += 1
            menuSeparator.Visible = True
        End Sub

        Sub Remove(ByVal window As Form)
            Dim i As Integer = window.Tag
            windowMenu.MenuItems.Remove(subWindows(i).windowMenuItem)
            subWindows(i).valid = False
            menuHandles(i) = System.IntPtr.Zero
            winsCount -= 1
            If winsCount = 0 Then menuSeparator.Visible = False
        End Sub

        Sub RefreshCaption(ByVal window As Form)
            subWindows(window.Tag).windowMenuItem.Text = window.Text
        End Sub

        Sub CloseAll()
            For i As Integer = 0 To maxWins - 1
                If subWindows(i).valid Then
                    subWindows(i).window.Close()
                    windowMenu.MenuItems.Remove(subWindows(i).windowMenuItem)
                    subWindows(i).valid = False
                    menuHandles(i) = System.IntPtr.Zero
                End If
            Next i
            winsCount = 0
            menuSeparator.Visible = False
        End Sub

        Public Sub New(ByVal menu As MenuItem)
            windowMenu = menu
            menuSeparator = New MenuItem
            menuSeparator.Text = "-"
            menu.MenuItems.Add(menuSeparator)
            menuSeparator.Visible = False
        End Sub
    End Class

    Public Function getClientHandle() As String
        Static clientHandle As Int32
        If clientHandle = 0 Then
            Dim r As New Random
            clientHandle = r.Next(1000000000 - 1) + 1
        End If
        clientHandle = (clientHandle + 1) Mod 1000000000.0
        Return Format(clientHandle.ToString.PadLeft(9, "0"))
    End Function
    Public Function timeToString(ByVal time As DateTime) As String
        Return time.Hour.ToString() + ":" + time.Minute.ToString() + ":" + time.Second.ToString() + "." + time.Millisecond.ToString()
    End Function

    Public Function setServer(ByVal SrvUrl As String) As String
        Try
            Srv.Url = SrvUrl
        Catch err As Exception
            Return (SrvUrl + ": " + err.Message)
        End Try
        formMainI.SBPUrl.Text = Srv.Url
        Return ""
    End Function

    Sub main()
        formMainI = New formMain
        Dim SrvUrl As String = formURLdlg.cbServiceUrl.Items(0)
        formURLdlg.cbServiceUrl.Text = SrvUrl
        Dim r As String = setServer(SrvUrl)
        If r <> "" Then
            formMainI.addToLog(r)
        Else
            formMainI.refreshBranches()
        End If

        formMainI.ShowDialog()
    End Sub

    Public Function isntNothing(ByVal s As Object) As String
        If IsNothing(s) Then Return "" Else Return s.ToString
    End Function


    Public Function joinItemName(ByRef path As String, ByRef name As String) As String
        If path = "" Then
            Return name
        Else
            Return path + BranchSepChar + name
        End If

    End Function

    Public Sub splitItemName(ByVal ItemName As String, ByRef path As String, ByRef name As String)
        Dim isp As Array = ItemName.Split(BranchSepChar)
        name = isp(isp.Length - 1)
        If isp.Length > 1 Then
            path = ItemName.Substring(0, ItemName.Length - name.Length - 1)
        Else
            path = ""
        End If
    End Sub
    Public Sub tb2Integer(ByRef tb As TextBox, ByVal defaultvalue As String)
        Dim i As Integer
        Try
            i = CInt(tb.Text)
            tb.Text = i.ToString
        Catch
            tb.Text = defaultvalue
        End Try
    End Sub
    Public Sub tb2Single(ByRef tb As TextBox, ByVal defaultvalue As String)
        Dim v As Single
        Try
            v = CSng(tb.Text)
            tb.Text = v.ToString
        Catch
            tb.Text = defaultvalue
        End Try
    End Sub
    Public Sub tb2Date(ByRef tb As TextBox, ByVal defaultvalue As String)
        Dim v As Date
        Try
            v = CDate(tb.Text)
            tb.Text = v.ToString
        Catch
            tb.Text = defaultvalue
        End Try
    End Sub
    Public Sub copyIf(ByRef dest As Object, ByVal source As Object)
        If (CStr(source) <> "") Then dest = source
    End Sub
    Public Sub copyIf2(ByRef dest As Integer, ByVal source As Integer)
        If (source <> -1) Then dest = source
    End Sub

    Public Sub copyIfcond(ByRef dest As Object, ByVal source As Object, ByRef cond As Boolean)
        cond = (CStr(source) <> "")
        If cond Then dest = source
    End Sub
    Public Sub copyIf2cond(ByRef dest As Integer, ByVal source As Integer, ByRef cond As Boolean)
        cond = (source <> -1)
        If cond Then dest = source
    End Sub

    Public Function Date2SecOfDay(ByVal d As Date) As Double
        Return d.TimeOfDay().TotalSeconds
    End Function
End Module

