Public Class formMain
    Inherits System.Windows.Forms.Form

    'Dim lastPropRefresh As Double
    Private formReadCount As Integer
    Private formWriteCount As Integer
    Private formSubscribeCount As Integer
    Private ItemNameFilter As String

    Private Function getCurrentPath() As String
        If IsNothing(tvBranches.SelectedNode) Then Return ""
        Dim path As String = tvBranches.SelectedNode.FullPath

        If path = tvBranches.Nodes.Item(0).Text Then
            path = ""
        Else
            path = path.Substring(tvBranches.Nodes.Item(0).Text.Length + 1)
        End If
        SBPPath.Text = path
        Return path
    End Function
    Private Function getCurrentItem() As String
        If lvItems.SelectedItems.Count <> 1 Then Return ""
        If tvBranches.SelectedNode Is tvBranches.Nodes.Item(0) Then
            Return lvItems.SelectedItems.Item(0).Text
        Else
            Return getCurrentPath() + BranchSepChar + lvItems.SelectedItems.Item(0).Text
        End If
    End Function

    Public Sub addToLog(ByVal s As String)
        Dim newtext As String = Join(s.Split(Chr(10)), Chr(13) + Chr(10)) + Chr(13) + Chr(10)
        Dim ex As Integer = tbLog.Text.Length + newtext.Length - tbLog.MaxLength
        If ex > 0 Then
            tbLog.Text = tbLog.Text.Remove(0, tbLog.Text.IndexOf(Chr(10), ex + 150) + 1) + newtext
        Else
            tbLog.Text += newtext
        End If
        tbLog.SelectionStart = tbLog.TextLength
        tbLog.ScrollToCaret()
    End Sub

    Public Sub callGetStatus()
        Dim reply As ReplyBase
        Dim status As ServerStatus
        Dim SendTime As Date = Now()
        Try
            reply = Srv.GetStatus(LocaleID, getClientHandle(), status)
            Dim li As String
            If status.SupportedLocaleIDs.Length Then
                For Each lid As String In status.SupportedLocaleIDs
                    If li <> "" Then li += ",  "
                    li += lid
                Next
            End If
            Dim iv As String = ""
            If status.SupportedInterfaceVersions.Length Then
                For Each ivd As interfaceVersion In status.SupportedInterfaceVersions
                    If iv <> "" Then iv += ",  "
                    iv += ivd.ToString()
                Next
            End If

            Dim lst As String
            lst = "Server avviato alle: " + timeToString(status.StartTime)
            Dim rss As String
            rss = "Server State: " + reply.ServerState.ToString()
            Dim tel As String
            tel = "Tempo trascorso dalla richiesta: " & Now.Subtract(SendTime).TotalSeconds & " secondi"

            addToLog(Chr(10) + "Vendors: " + status.VendorInfo + Chr(10) + _
                "Product Version: " + status.ProductVersion + Chr(10) + _
                "Status Info: " + status.StatusInfo + Chr(10) + _
                "Interface Version: " + iv + Chr(10) + _
                "Locale Ids: " + li + Chr(10) + _
                lst + Chr(10) + rss + Chr(10) + _
                "Revised Locale Id: " + reply.RevisedLocaleID + Chr(10) + tel + Chr(10))
        Catch err As Exception
            addToLog(err.Message)
        End Try
    End Sub

    Public Sub makeTree(ByRef node As System.Windows.Forms.TreeNode, ByVal path As String)

        Dim Items() As BrowseElement
        Dim Errors() As OPCError
        Dim MoreElements As Boolean
        Dim reply As ReplyBase
        Dim ContPoint As String


        Dim prop() As System.Xml.XmlQualifiedName

        Try
            reply = Srv.Browse(prop, LocaleID, getClientHandle(), "", path, ContPoint, MAX_ELEMENTS_RET, browseFilter.branch, "", "", False, False, True, Items, Errors, MoreElements)


            'stampa errori e descrizioni
            For Each err As OPCError In Errors
                addToLog(err.ID.Name + "    " + err.Text)
            Next

            Dim bi As BrowseElement

            For Each bi In Items
                Dim newNode As New System.Windows.Forms.TreeNode

                newNode.Text = bi.Name
                'l'attributo Name dovrebbe essere uguale all'ultima parte di ItemName:
                'paths = bi.ItemName.Split(BranchSepChar) : newNode.Text = paths(paths.Length - 1)
                If bi.HasChildren Then makeTree(newNode, bi.ItemName)
                node.Nodes.Add(newNode)
            Next

            If MoreElements Then addToLog("Esistono pi di " + MAX_ELEMENTS_RET + " elementi")
        Catch err As Exception
            addToLog(err.Message)
        End Try
    End Sub

    Private Sub refreshItems()
        Dim Items() As BrowseElement
        Dim Errors() As OPCError
        Dim MoreElements As Boolean
        Dim reply As ReplyBase
        Dim ContPoint As String
        Dim path As String = getCurrentPath()
        Dim clientHandle = getClientHandle()

        Me.Cursor = Cursors.WaitCursor

        Dim prop() As System.Xml.XmlQualifiedName

        lvItems.Items.Clear()
        lvProperties.Items.Clear()

        Try
            'Do
            reply = Srv.Browse(prop, LocaleID, clientHandle, "", path, ContPoint, MAX_ELEMENTS_RET, browseFilter.item, ItemNameFilter, "", False, False, True, Items, Errors, MoreElements)
            For Each err As OPCError In Errors
                addToLog(err.ID.Name + "    " + err.Text)
            Next

            Dim bi As BrowseElement

            For Each bi In Items
                lvItems.Items.Add(bi.Name, 2)
            Next
            If MoreElements Then addToLog("Esistono pi di " + MAX_ELEMENTS_RET + " elementi")
            'Loop While MoreElements
        Catch err As Exception
            addToLog(err.Message)
        End Try
        Me.Cursor = Cursors.Default
    End Sub
    Private Sub refreshProperties()
        lvProperties.Items.Clear()
        If lvItems.SelectedItems.Count <> 1 Then Exit Sub
        Dim iId(1) As ItemIdentifier
        iId(0) = New ItemIdentifier
        Dim prop() As System.Xml.XmlQualifiedName
        Dim propReply() As PropertyReplyList
        Dim errors() As OPCError
        Dim reply As ReplyBase

        iId(0).ItemName = getCurrentItem()

        Try
            reply = Srv.GetProperties(iId, prop, LocaleID, getClientHandle(), "", True, True, True, propReply, errors)

            For Each err As OPCError In errors
                addToLog(err.ID.Name + "    " + err.Text)
            Next

            Dim pl As PropertyReplyList
            For Each pl In propReply
                If Not IsNothing(pl.Properties) Then
                    For i As Integer = 0 To pl.Properties.GetLength(0) - 1
                        Dim newProp As New ListViewItem
                        newProp.SubItems.Add("")
                        newProp.SubItems.Add("")
                        newProp.SubItems.Add("")
                        'newProp.Text = pl.Properties(i).Name.ToString
                        'newProp.SubItems(0).Text = pl.Properties(i).Name.ToString
                        If Not IsNothing(pl.Properties(i).Value) Then newProp.SubItems(1).Text = pl.Properties(i).Value.ToString
                        If Not IsNothing(pl.Properties(i).ResultID) Then newProp.SubItems(2).Text = pl.Properties(i).ResultID.Name
                        If Not IsNothing(pl.Properties(i).Description) Then
                            newProp.SubItems(0).Text = pl.Properties(i).Description
                        Else
                            newProp.SubItems(0).Text = isntNothing(pl.Properties(i).Name)
                        End If
                        lvProperties.Items.Add(newProp)
                    Next i
                End If
            Next pl

            Dim newItem As ListViewItem
        Catch err As Exception
            addToLog(err.Message)
        End Try
    End Sub


#Region " Codice generato da Progettazione Windows Form "


    Public Sub New()
        MyBase.New()

        'Chiamata richiesta da Progettazione Windows Form.
        InitializeComponent()

        'Aggiungere le eventuali istruzioni di inizializzazione dopo la chiamata a InitializeComponent()
        For Each mi As MenuItem In cmItms.MenuItems
            If (Not IsNothing(mi)) Then
                menuItms.MenuItems.Add(mi.CloneMenu())
            End If
        Next mi

        subWinColl = New SubWindowCollection(MenuWindow)
    End Sub


    'Form esegue l'override del metodo Dispose per pulire l'elenco dei componenti.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Richiesto da Progettazione Windows Form
    Private components As System.ComponentModel.IContainer

    'NOTA: la procedura che segue  richiesta da Progettazione Windows Form.
    'Pu essere modificata in Progettazione Windows Form.  
    'Non modificarla nell'editor del codice.
    Friend WithEvents tvBranches As System.Windows.Forms.TreeView
    Friend WithEvents tbLog As System.Windows.Forms.TextBox
    Friend WithEvents SplitterV As System.Windows.Forms.Splitter
    Friend WithEvents SplitterH As System.Windows.Forms.Splitter
    Friend WithEvents ilFolders As System.Windows.Forms.ImageList
    Friend WithEvents toolBar As System.Windows.Forms.ToolBar
    Friend WithEvents ilToolbar As System.Windows.Forms.ImageList
    Friend WithEvents tbbURL As System.Windows.Forms.ToolBarButton
    Friend WithEvents GetStatus As System.Windows.Forms.ToolBarButton
    Friend WithEvents tbbRefresh As System.Windows.Forms.ToolBarButton
    Friend WithEvents tbSeparator1 As System.Windows.Forms.ToolBarButton
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents lvItems As System.Windows.Forms.ListView
    Friend WithEvents SplitterH2 As System.Windows.Forms.Splitter
    Friend WithEvents lvProperties As System.Windows.Forms.ListView
    Friend WithEvents ColumnHeader1 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader2 As System.Windows.Forms.ColumnHeader
    Friend WithEvents ColumnHeader3 As System.Windows.Forms.ColumnHeader
    Friend WithEvents StatusBar As System.Windows.Forms.StatusBar
    Friend WithEvents SBPUrl As System.Windows.Forms.StatusBarPanel
    Friend WithEvents SBPPath As System.Windows.Forms.StatusBarPanel
    Friend WithEvents MainMenu As System.Windows.Forms.MainMenu
    Friend WithEvents menuItms As System.Windows.Forms.MenuItem
    Friend WithEvents cmItms As System.Windows.Forms.ContextMenu
    Friend WithEvents menuItmCopia As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItmSel As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItmMod As System.Windows.Forms.MenuItem
    Friend WithEvents menuItmSep As System.Windows.Forms.MenuItem
    Friend WithEvents tbbAddWin1 As System.Windows.Forms.ToolBarButton
    Friend WithEvents tbbSeparetor2 As System.Windows.Forms.ToolBarButton
    Friend WithEvents tbbAddWin2 As System.Windows.Forms.ToolBarButton
    Friend WithEvents tbbAddWin3 As System.Windows.Forms.ToolBarButton
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem6 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem10 As System.Windows.Forms.MenuItem
    Friend WithEvents menuURL As System.Windows.Forms.MenuItem
    Friend WithEvents menuClose As System.Windows.Forms.MenuItem
    Friend WithEvents menuGetSatus As System.Windows.Forms.MenuItem
    Friend WithEvents menuOpt As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem12 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem7 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuWindow As System.Windows.Forms.MenuItem
    Friend WithEvents menuRefresh As System.Windows.Forms.MenuItem
    Friend WithEvents menuRefresh1 As System.Windows.Forms.MenuItem
    Friend WithEvents menuRefresh2 As System.Windows.Forms.MenuItem
    Friend WithEvents menuRefresh3 As System.Windows.Forms.MenuItem
    Friend WithEvents menuAddWin1 As System.Windows.Forms.MenuItem
    Friend WithEvents menuAddWin2 As System.Windows.Forms.MenuItem
    Friend WithEvents menuAddWin3 As System.Windows.Forms.MenuItem
    Friend WithEvents menuInfo As System.Windows.Forms.MenuItem
    Friend WithEvents menuItmFiltro As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem3 As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(formMain))
        Me.tvBranches = New System.Windows.Forms.TreeView
        Me.ilFolders = New System.Windows.Forms.ImageList(Me.components)
        Me.tbLog = New System.Windows.Forms.TextBox
        Me.toolBar = New System.Windows.Forms.ToolBar
        Me.tbbURL = New System.Windows.Forms.ToolBarButton
        Me.GetStatus = New System.Windows.Forms.ToolBarButton
        Me.tbbRefresh = New System.Windows.Forms.ToolBarButton
        Me.tbSeparator1 = New System.Windows.Forms.ToolBarButton
        Me.tbbAddWin1 = New System.Windows.Forms.ToolBarButton
        Me.tbbAddWin2 = New System.Windows.Forms.ToolBarButton
        Me.tbbAddWin3 = New System.Windows.Forms.ToolBarButton
        Me.tbbSeparetor2 = New System.Windows.Forms.ToolBarButton
        Me.ilToolbar = New System.Windows.Forms.ImageList(Me.components)
        Me.SplitterV = New System.Windows.Forms.Splitter
        Me.SplitterH = New System.Windows.Forms.Splitter
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.lvItems = New System.Windows.Forms.ListView
        Me.cmItms = New System.Windows.Forms.ContextMenu
        Me.menuItmCopia = New System.Windows.Forms.MenuItem
        Me.MenuItmSel = New System.Windows.Forms.MenuItem
        Me.menuItmSep = New System.Windows.Forms.MenuItem
        Me.MenuItmMod = New System.Windows.Forms.MenuItem
        Me.SplitterH2 = New System.Windows.Forms.Splitter
        Me.lvProperties = New System.Windows.Forms.ListView
        Me.ColumnHeader1 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader2 = New System.Windows.Forms.ColumnHeader
        Me.ColumnHeader3 = New System.Windows.Forms.ColumnHeader
        Me.StatusBar = New System.Windows.Forms.StatusBar
        Me.SBPUrl = New System.Windows.Forms.StatusBarPanel
        Me.SBPPath = New System.Windows.Forms.StatusBarPanel
        Me.MainMenu = New System.Windows.Forms.MainMenu
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.menuURL = New System.Windows.Forms.MenuItem
        Me.MenuItem10 = New System.Windows.Forms.MenuItem
        Me.menuGetSatus = New System.Windows.Forms.MenuItem
        Me.menuOpt = New System.Windows.Forms.MenuItem
        Me.MenuItem6 = New System.Windows.Forms.MenuItem
        Me.menuClose = New System.Windows.Forms.MenuItem
        Me.menuItms = New System.Windows.Forms.MenuItem
        Me.menuItmFiltro = New System.Windows.Forms.MenuItem
        Me.MenuItem3 = New System.Windows.Forms.MenuItem
        Me.MenuWindow = New System.Windows.Forms.MenuItem
        Me.menuRefresh = New System.Windows.Forms.MenuItem
        Me.menuRefresh1 = New System.Windows.Forms.MenuItem
        Me.menuRefresh2 = New System.Windows.Forms.MenuItem
        Me.menuRefresh3 = New System.Windows.Forms.MenuItem
        Me.MenuItem7 = New System.Windows.Forms.MenuItem
        Me.menuAddWin1 = New System.Windows.Forms.MenuItem
        Me.menuAddWin2 = New System.Windows.Forms.MenuItem
        Me.menuAddWin3 = New System.Windows.Forms.MenuItem
        Me.MenuItem12 = New System.Windows.Forms.MenuItem
        Me.menuInfo = New System.Windows.Forms.MenuItem
        Me.Panel1.SuspendLayout()
        CType(Me.SBPUrl, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.SBPPath, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'tvBranches
        '
        Me.tvBranches.Dock = System.Windows.Forms.DockStyle.Left
        Me.tvBranches.ImageList = Me.ilFolders
        Me.tvBranches.Location = New System.Drawing.Point(0, 42)
        Me.tvBranches.Name = "tvBranches"
        Me.tvBranches.PathSeparator = "."
        Me.tvBranches.SelectedImageIndex = 1
        Me.tvBranches.Size = New System.Drawing.Size(264, 265)
        Me.tvBranches.TabIndex = 0
        '
        'ilFolders
        '
        Me.ilFolders.ImageSize = New System.Drawing.Size(16, 16)
        Me.ilFolders.ImageStream = CType(resources.GetObject("ilFolders.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ilFolders.TransparentColor = System.Drawing.Color.Maroon
        '
        'tbLog
        '
        Me.tbLog.AutoSize = False
        Me.tbLog.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.tbLog.Location = New System.Drawing.Point(0, 315)
        Me.tbLog.Multiline = True
        Me.tbLog.Name = "tbLog"
        Me.tbLog.ReadOnly = True
        Me.tbLog.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.tbLog.Size = New System.Drawing.Size(616, 120)
        Me.tbLog.TabIndex = 11
        Me.tbLog.Text = ""
        '
        'toolBar
        '
        Me.toolBar.Buttons.AddRange(New System.Windows.Forms.ToolBarButton() {Me.tbbURL, Me.GetStatus, Me.tbbRefresh, Me.tbSeparator1, Me.tbbAddWin1, Me.tbbAddWin2, Me.tbbAddWin3, Me.tbbSeparetor2})
        Me.toolBar.ButtonSize = New System.Drawing.Size(55, 36)
        Me.toolBar.DropDownArrows = True
        Me.toolBar.ImageList = Me.ilToolbar
        Me.toolBar.Location = New System.Drawing.Point(0, 0)
        Me.toolBar.Name = "toolBar"
        Me.toolBar.ShowToolTips = True
        Me.toolBar.Size = New System.Drawing.Size(616, 42)
        Me.toolBar.TabIndex = 3
        '
        'tbbURL
        '
        Me.tbbURL.ImageIndex = 0
        Me.tbbURL.Text = "Server"
        Me.tbbURL.ToolTipText = "Seleziona il web service"
        '
        'GetStatus
        '
        Me.GetStatus.ImageIndex = 1
        Me.GetStatus.Text = "GetStatus"
        Me.GetStatus.ToolTipText = "Richiede le informazioni sullo stato del server"
        '
        'tbbRefresh
        '
        Me.tbbRefresh.ImageIndex = 2
        Me.tbbRefresh.Text = "Refresh"
        Me.tbbRefresh.ToolTipText = "Aggiorna l'albero dei gruppi"
        '
        'tbSeparator1
        '
        Me.tbSeparator1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
        '
        'tbbAddWin1
        '
        Me.tbbAddWin1.ImageIndex = 3
        Me.tbbAddWin1.Text = "Read list"
        Me.tbbAddWin1.ToolTipText = "Crea una lista di Item da leggere"
        '
        'tbbAddWin2
        '
        Me.tbbAddWin2.ImageIndex = 3
        Me.tbbAddWin2.Text = "Subscribe"
        Me.tbbAddWin2.ToolTipText = "Crea una finestra di subscription"
        '
        'tbbAddWin3
        '
        Me.tbbAddWin3.ImageIndex = 3
        Me.tbbAddWin3.Text = "Write list"
        Me.tbbAddWin3.ToolTipText = "Crea una lista di Item da aggiornare"
        '
        'tbbSeparetor2
        '
        Me.tbbSeparetor2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
        '
        'ilToolbar
        '
        Me.ilToolbar.ImageSize = New System.Drawing.Size(16, 16)
        Me.ilToolbar.ImageStream = CType(resources.GetObject("ilToolbar.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ilToolbar.TransparentColor = System.Drawing.Color.Maroon
        '
        'SplitterV
        '
        Me.SplitterV.Location = New System.Drawing.Point(264, 42)
        Me.SplitterV.Name = "SplitterV"
        Me.SplitterV.Size = New System.Drawing.Size(8, 265)
        Me.SplitterV.TabIndex = 5
        Me.SplitterV.TabStop = False
        '
        'SplitterH
        '
        Me.SplitterH.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.SplitterH.Location = New System.Drawing.Point(0, 307)
        Me.SplitterH.Name = "SplitterH"
        Me.SplitterH.Size = New System.Drawing.Size(616, 8)
        Me.SplitterH.TabIndex = 6
        Me.SplitterH.TabStop = False
        '
        'Panel1
        '
        Me.Panel1.Controls.Add(Me.lvItems)
        Me.Panel1.Controls.Add(Me.SplitterH2)
        Me.Panel1.Controls.Add(Me.lvProperties)
        Me.Panel1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.Panel1.Location = New System.Drawing.Point(272, 42)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(344, 265)
        Me.Panel1.TabIndex = 8
        '
        'lvItems
        '
        Me.lvItems.ContextMenu = Me.cmItms
        Me.lvItems.Dock = System.Windows.Forms.DockStyle.Fill
        Me.lvItems.HideSelection = False
        Me.lvItems.Location = New System.Drawing.Point(0, 0)
        Me.lvItems.Name = "lvItems"
        Me.lvItems.Size = New System.Drawing.Size(344, 121)
        Me.lvItems.SmallImageList = Me.ilFolders
        Me.lvItems.TabIndex = 8
        Me.lvItems.View = System.Windows.Forms.View.List
        '
        'cmItms
        '
        Me.cmItms.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuItmCopia, Me.MenuItmSel, Me.menuItmSep, Me.MenuItmMod})
        '
        'menuItmCopia
        '
        Me.menuItmCopia.Index = 0
        Me.menuItmCopia.Shortcut = System.Windows.Forms.Shortcut.CtrlC
        Me.menuItmCopia.Text = "&Copia"
        '
        'MenuItmSel
        '
        Me.MenuItmSel.Index = 1
        Me.MenuItmSel.MergeOrder = 1
        Me.MenuItmSel.Shortcut = System.Windows.Forms.Shortcut.CtrlA
        Me.MenuItmSel.Text = "Seleziona &tutti"
        '
        'menuItmSep
        '
        Me.menuItmSep.Index = 2
        Me.menuItmSep.MergeOrder = 2
        Me.menuItmSep.Text = "-"
        '
        'MenuItmMod
        '
        Me.MenuItmMod.Enabled = False
        Me.MenuItmMod.Index = 3
        Me.MenuItmMod.MergeOrder = 3
        Me.MenuItmMod.Shortcut = System.Windows.Forms.Shortcut.CtrlE
        Me.MenuItmMod.Text = "&Modifica"
        '
        'SplitterH2
        '
        Me.SplitterH2.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.SplitterH2.Location = New System.Drawing.Point(0, 121)
        Me.SplitterH2.Name = "SplitterH2"
        Me.SplitterH2.Size = New System.Drawing.Size(344, 8)
        Me.SplitterH2.TabIndex = 9
        Me.SplitterH2.TabStop = False
        '
        'lvProperties
        '
        Me.lvProperties.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ColumnHeader1, Me.ColumnHeader2, Me.ColumnHeader3})
        Me.lvProperties.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.lvProperties.Location = New System.Drawing.Point(0, 129)
        Me.lvProperties.Name = "lvProperties"
        Me.lvProperties.Size = New System.Drawing.Size(344, 136)
        Me.lvProperties.TabIndex = 10
        Me.lvProperties.View = System.Windows.Forms.View.Details
        '
        'ColumnHeader1
        '
        Me.ColumnHeader1.Text = "Propriet"
        Me.ColumnHeader1.Width = 120
        '
        'ColumnHeader2
        '
        Me.ColumnHeader2.Text = "Valore"
        Me.ColumnHeader2.Width = 120
        '
        'ColumnHeader3
        '
        Me.ColumnHeader3.Text = "Errori"
        Me.ColumnHeader3.Width = 94
        '
        'StatusBar
        '
        Me.StatusBar.Location = New System.Drawing.Point(0, 435)
        Me.StatusBar.Name = "StatusBar"
        Me.StatusBar.Panels.AddRange(New System.Windows.Forms.StatusBarPanel() {Me.SBPUrl, Me.SBPPath})
        Me.StatusBar.ShowPanels = True
        Me.StatusBar.Size = New System.Drawing.Size(616, 22)
        Me.StatusBar.TabIndex = 9
        '
        'SBPUrl
        '
        Me.SBPUrl.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring
        Me.SBPUrl.Width = 590
        '
        'SBPPath
        '
        Me.SBPPath.Alignment = System.Windows.Forms.HorizontalAlignment.Right
        Me.SBPPath.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents
        Me.SBPPath.Width = 10
        '
        'MainMenu
        '
        Me.MainMenu.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem1, Me.menuItms, Me.MenuWindow, Me.MenuItem12})
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 0
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuURL, Me.MenuItem10, Me.menuGetSatus, Me.menuOpt, Me.MenuItem6, Me.menuClose})
        Me.MenuItem1.Text = "&Server"
        '
        'menuURL
        '
        Me.menuURL.Index = 0
        Me.menuURL.Text = "Seleziona &web service..."
        '
        'MenuItem10
        '
        Me.MenuItem10.Index = 1
        Me.MenuItem10.Text = "-"
        '
        'menuGetSatus
        '
        Me.menuGetSatus.Index = 2
        Me.menuGetSatus.Text = "&Stato"
        '
        'menuOpt
        '
        Me.menuOpt.Index = 3
        Me.menuOpt.Text = "&Opzioni..."
        '
        'MenuItem6
        '
        Me.MenuItem6.Index = 4
        Me.MenuItem6.Text = "-"
        '
        'menuClose
        '
        Me.menuClose.Index = 5
        Me.menuClose.Text = "&Chiudi"
        '
        'menuItms
        '
        Me.menuItms.Index = 1
        Me.menuItms.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuItmFiltro, Me.MenuItem3})
        Me.menuItms.Text = "&Item"
        '
        'menuItmFiltro
        '
        Me.menuItmFiltro.Index = 0
        Me.menuItmFiltro.Shortcut = System.Windows.Forms.Shortcut.CtrlF
        Me.menuItmFiltro.Text = "&Filtro..."
        '
        'MenuItem3
        '
        Me.MenuItem3.Index = 1
        Me.MenuItem3.Text = "-"
        '
        'MenuWindow
        '
        Me.MenuWindow.Index = 2
        Me.MenuWindow.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuRefresh, Me.MenuItem7, Me.menuAddWin1, Me.menuAddWin2, Me.menuAddWin3})
        Me.MenuWindow.Text = "&Finestra"
        '
        'menuRefresh
        '
        Me.menuRefresh.Index = 0
        Me.menuRefresh.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuRefresh1, Me.menuRefresh2, Me.menuRefresh3})
        Me.menuRefresh.Text = "&Refresh"
        '
        'menuRefresh1
        '
        Me.menuRefresh1.Index = 0
        Me.menuRefresh1.Text = "&Gruppi"
        '
        'menuRefresh2
        '
        Me.menuRefresh2.Index = 1
        Me.menuRefresh2.Shortcut = System.Windows.Forms.Shortcut.F5
        Me.menuRefresh2.Text = "&Items"
        '
        'menuRefresh3
        '
        Me.menuRefresh3.Index = 2
        Me.menuRefresh3.Shortcut = System.Windows.Forms.Shortcut.F6
        Me.menuRefresh3.Text = "&Propriet"
        '
        'MenuItem7
        '
        Me.MenuItem7.Index = 1
        Me.MenuItem7.Text = "-"
        '
        'menuAddWin1
        '
        Me.menuAddWin1.Index = 2
        Me.menuAddWin1.Text = "Nuova &reading list"
        '
        'menuAddWin2
        '
        Me.menuAddWin2.Index = 3
        Me.menuAddWin2.Text = "Nuova &subsciption list"
        '
        'menuAddWin3
        '
        Me.menuAddWin3.Index = 4
        Me.menuAddWin3.Text = "Nuova &write list"
        '
        'MenuItem12
        '
        Me.MenuItem12.Index = 3
        Me.MenuItem12.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuInfo})
        Me.MenuItem12.Text = "&?"
        '
        'menuInfo
        '
        Me.menuInfo.Index = 0
        Me.menuInfo.Text = "&Informazioni su OPC XML-DA Client..."
        '
        'formMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(616, 457)
        Me.Controls.Add(Me.Panel1)
        Me.Controls.Add(Me.SplitterV)
        Me.Controls.Add(Me.tvBranches)
        Me.Controls.Add(Me.toolBar)
        Me.Controls.Add(Me.SplitterH)
        Me.Controls.Add(Me.tbLog)
        Me.Controls.Add(Me.StatusBar)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Menu = Me.MainMenu
        Me.Name = "formMain"
        Me.Text = "OPC XML-DA Client"
        Me.Panel1.ResumeLayout(False)
        CType(Me.SBPUrl, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.SBPPath, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub formMain_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        On Error Resume Next
        FileSystem.FileOpen(1, "OpcXmlDa.SrvUrls", OpenMode.Output, OpenAccess.Write)
        For Each i As String In formURLdlg.cbServiceUrl.Items
            FileSystem.PrintLine(1, i)
        Next i
        FileSystem.FileClose(1)
        End
    End Sub

    Public Sub refreshBranches()
        Dim newNode As New System.Windows.Forms.TreeNode
        Me.Cursor = Cursors.WaitCursor 'fa apparire la clessidra
        tvBranches.Nodes.Clear()       'cancella l'albero esistente
        newNode.Text = "Server"
        makeTree(newNode, "")
        tvBranches.Nodes.Add(newNode)  'crea il nodo principale
        lvItems.Items.Clear()
        lvProperties.Items.Clear()
        Me.Cursor = Cursors.Default
    End Sub


    Private Sub toolBar_ButtonClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ToolBarButtonClickEventArgs) Handles toolBar.ButtonClick
        Select Case e.Button.Text
            Case "Server"
                menuURL_Click(sender, e)
            Case "GetStatus"
                callGetStatus()
            Case "Refresh"
                refreshBranches()
            Case "Read list"
                menuAddWin1_Click(sender, e)
            Case "Subscribe"
                menuAddWin2_Click(sender, e)
            Case "Write list"
                menuAddWin3_Click(sender, e)
        End Select
    End Sub


    Private Sub tvBranches_AfterSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles tvBranches.AfterSelect
        refreshItems()
    End Sub

    Private Sub lvItems_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvItems.SelectedIndexChanged
        MenuItmMod.Enabled = (lvItems.SelectedItems.Count = 1)
        menuItms.MenuItems(menuItms.MenuItems.Count - 1).Enabled = MenuItmMod.Enabled
        refreshProperties()
    End Sub

    Private Sub lvItems_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lvItems.Click
        'refreshProperties()
    End Sub

    Private Sub lvItems_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles lvItems.KeyPress
        If e.KeyChar = Chr(13) Then refreshProperties()
    End Sub


    Private Sub lvItems_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lvItems.MouseDown
        'If e.Button = MouseButtons.Left And (lvItems.SelectedItems.Count > 0) Then
        '    lvItems.DoDragDrop(lvItems.SelectedItems, DragDropEffects.Copy)
        'End If
    End Sub


    Private Sub MenuItmMod_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItmMod.Click
        Dim fe As New formEdit
        fe.setItemPath(getCurrentItem())
        fe.ShowDialog()
    End Sub



    Private Sub MenuItmSel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItmSel.Click
        For Each i As ListViewItem In lvItems.Items
            i.Selected = True
        Next i
    End Sub

    Private Sub menuItmCopia_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItmCopia.Click
        Dim path As String = getCurrentPath()
        If path <> "" Then path += BranchSepChar
        itemsClipboard.Clear()
        For Each i As ListViewItem In lvItems.SelectedItems
            itemsClipboard.Add(path + i.Text)
        Next i
    End Sub

    Private Sub menuGetSatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuGetSatus.Click
        callGetStatus()
    End Sub

    Private Sub menuClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuClose.Click
        Close()
    End Sub

    Private Sub menuURL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuURL.Click
        formURLdlg.cbServiceUrl.SelectedIndex = 0
        formURLdlg.Owner = Me
        Dim PrevSrvUrl As String = Srv.Url
        formURLdlg.ShowDialog()
        If PrevSrvUrl <> Srv.Url Then
            formReadCount = 0
            formWriteCount = 0
            formSubscribeCount = 0
            subWinColl.CloseAll()
            refreshBranches()
        End If
    End Sub

    Private Sub menuRefresh1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuRefresh1.Click
        refreshBranches()
    End Sub

    Private Sub menuRefresh2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuRefresh2.Click
        refreshItems()
    End Sub

    Private Sub menuRefresh3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuRefresh3.Click
        refreshProperties()
    End Sub

    Private Sub menuAddWin1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuAddWin1.Click
        Dim nfr As New formRead
        formReadCount += 1
        nfr.Text += " (" + CStr(formReadCount) + ")"
        subWinColl.Add(nfr)
        nfr.Show()
    End Sub

    Private Sub menuAddWin2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuAddWin2.Click
        Dim nfr As New formSubscribe
        formSubscribeCount += 1
        nfr.Text += " (" + CStr(formSubscribeCount) + ")"
        subWinColl.Add(nfr)
        nfr.Show()
    End Sub

    Private Sub menuAddWin3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuAddWin3.Click
        Dim nfr As New formWrite
        formWriteCount += 1
        nfr.Text += " (" + CStr(formWriteCount) + ")"
        subWinColl.Add(nfr)
        nfr.Show()
    End Sub

    Private Sub menuOpt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuOpt.Click
        Dim formOptionsI As New formOptions

        formOptionsI.txtLocaleID.Text = LocaleID
        formOptionsI.cbBranchSepChar.Text = BranchSepChar
        formOptionsI.ShowDialog()
    End Sub


    Private Sub menuInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuInfo.Click
        Dim fa As New formAbout
        fa.ShowDialog(Me)
    End Sub

    Private Sub menuItmFiltro_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItmFiltro.Click
        Dim inp As String = InputBox("Inserisci il filtro per i nomi degli items." + Chr(10) + "Premi 'Annulla' per togliere il filtro", "Filtro", ItemNameFilter)
        If ItemNameFilter <> Trim(inp) Then
            ItemNameFilter = Trim(inp)
            refreshItems()
        End If
    End Sub
End Class
